libstdc++: __gnu_cxx::free_list Class Reference

libstdc++

__gnu_cxx::free_list Class Reference

`#include <bitmap_allocator.h>`

Inheritance diagram for __gnu_cxx::free_list:
[legend]

## Public Types
typedef __mutex | __mutex_type
typedef vector_type::iterator | iterator
typedef std::size_t * | value_type
typedef __detail::__mini_vector< value_type > | vector_type

## Public Member Functions
void | _M_clear ()
std::size_t * | _M_get (std::size_t __sz)
void | _M_insert (std::size_t *__addr) throw ()

## Detailed Description

The free list class for managing chunks of memory to be given to and returned by the bitmap_allocator.

Definition at line 517 of file bitmap_allocator.h.

## Member Typedef Documentation

## ◆ __mutex_type

typedef __mutex __gnu_cxx::free_list::__mutex_type

Definition at line 523 of file bitmap_allocator.h.

## ◆ iterator

typedef vector_type::iterator __gnu_cxx::free_list::iterator

Definition at line 522 of file bitmap_allocator.h.

## ◆ value_type

typedef std::size_t* __gnu_cxx::free_list::value_type

Definition at line 520 of file bitmap_allocator.h.

## ◆ vector_type

typedef __detail::__mini_vector<value_type> __gnu_cxx::free_list::vector_type

Definition at line 521 of file bitmap_allocator.h.

## Member Function Documentation

## ◆ _M_clear()

void __gnu_cxx::free_list::_M_clear | ( |  | ) |

This function just clears the internal Free List, and gives back all the memory to the OS.

## ◆ _M_get()

std::size_t * __gnu_cxx::free_list::_M_get | ( | std::size_t | __sz | ) |

This function gets a block of memory of the specified size from the free list.

Parameters

  __sz | The size in bytes of the memory required.

Returns
  A pointer to the new memory block of size at least equal to that requested.

## ◆ _M_insert()

void __gnu_cxx::free_list::_M_insert | ( | std::size_t * | __addr | ) |
throw | ( | ) |  |  |
| inline

This function returns the block of memory to the internal free list.

Parameters

  __addr | The pointer to the memory block that was given by a call to the _M_get function.

Definition at line 627 of file bitmap_allocator.h.

Referenced by __gnu_cxx::bitmap_allocator< _Tp1 >::_M_deallocate_single_object().

The documentation for this class was generated from the following file:

- bitmap_allocator.h